#!/usr/bin/env python

############################################################
#                                                          #
# Cut The Crap -- banner-unfriendly proxy-like server      #
#                                                          #
# Tested under linux, python 1.5.2, should work under all  #
# unices with thread-safe python installations (that would #
# be 1.5.0 or later).                                      #
#                                                          #
# Author: Constantinos A. Kotsokalis                       #
#         C.Kotsokalis@ece.ntua.gr                         #
# Release Date: Tue Jun  1 15:11:07 EEST 1999              #
# Release Policy: GNU Public License v2                    #
# Version: 0.1.0                                             #
#                                                          #
############################################################

import os, time, re, SocketServer, urlparse, string
from socket import *

BIND_PORT = 5050
PARENT_PROXY_HOST = ''  #Fill in with your organization's proxy server, if any
PARENT_PROXY_PORT = 8080  #Change to the correct port, if other than 8080
BUFF_SIZE = 8192
RETURN_GIF = '/usr/local/etc/white.gif'
RETURN_GIF_SIZE = 43
ADV_RET_BUFF = "HTTP/1.1 200 OK\nServer: Cut The Crap\nContent-Length: "+`RETURN_GIF_SIZE`+"\nConnection: close\nContent-Type: image/gif\n\n"

class MyTCPServer(SocketServer.ThreadingTCPServer):
	def server_bind(self):
		self.socket.setsockopt(SOL_SOCKET, SO_REUSEADDR, 1)
		self.socket.bind(self.server_address)

class handle_con:
	def __init__(req, sock, remaddr, srv):
		rhost, rport = remaddr
		req.proc_req(sock)

	def proc_req(self, sock):
		buff = sock.recv(BUFF_SIZE)
		if re.match(buff, ''):
			exit
		tokens = string.split(buff)
		if cre.search(tokens[1]):
			locf = open(RETURN_GIF, 'r')
			retgif = locf.read(RETURN_GIF_SIZE)
			locf.close()
			sock.send(ADV_RET_BUFF)
			sock.send(retgif)
			exit

		server = socket(AF_INET, SOCK_STREAM, IPPROTO_IP)
		if (len(PARENT_PROXY_HOST) == 0):
			url_tuple = urlparse.urlparse(tokens[1])
			host_port = url_tuple[1]
			if (re.search(host_port, ':')):
				rem_srv, rem_port = string.split(host_port, ':')
				rem_port = string.atoi(rem_port)
			else:
				rem_srv, rem_port = host_port, 80
			buff = string.replace(buff, tokens[1], url_tuple[2])
		else:
			rem_srv = PARENT_PROXY_HOST
			rem_port = PARENT_PROXY_PORT
			
		server.connect(rem_srv, rem_port)
		server.send(buff)
		retval = server.recv(BUFF_SIZE)
		while (retval):
			sock.send(retval)
			retval = server.recv(BUFF_SIZE)
		server.close()
		sock.close()
		exit


addr = '127.0.0.1', BIND_PORT
srv = MyTCPServer(addr, handle_con)
cre = re.compile("\/ad\/|\/ads\/|\/ads2\/|\/ad\.|\/ads\.|\/ads2\.|\.ad\.|\.ads\.|\/ads1\.|\.ads1\.|\/adv\/|\/cadv\/|\/adserver\.|\/adlog\.|\.adbannercenter\.|\/nsads\.|adclick\.|\/banner\.|\/banner\/|\/adverts\/|\.linkexchange\.|\/acc_clickthru|\/adfinity|event.ng|\/surfad|\/redirect\.|\/gen_addframe|\/m\=|\/ad\=|\/adclick\.|\/adfu\.|\?adnum\=|\.adzerver\.|\?advert\=|\/advert\/", re.I)
srv.serve_forever()

